;    
;   PIC12F675
;==============================================
;   
;==============================================
	list		p=12f675	;   
	#include	<P12f675.inc>	;  ,     
;==============================================
;  
;==============================================
	;    
	; _CPD_OFF -   EEPROM 
	; _CP_OFF -     
	; _BODEN_OFF -      
	; _MCLRE_OFF -  GP3/-MCLR      /
	; _PWRTE_ON -      
	; _WDT_ON -   
	; _INTRC_OSC_NOCLKOUT - INTOSC :  GP4   ,  GP5   
	__CONFIG _CPD_OFF & _CP_OFF & _BODEN_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT 
;==============================================
;  
;==============================================
TRISIO_CONST	EQU	B'00111011'	; GP2 - , GP0,GP1,GP3:GP5 - 
ADCON0_CONST	EQU	B'00000101'	; 7:0- , 6:0 - Uref - Vcc, 3,2:01 -  AN1, 1:0 - , 0:1 -  
ANSEL_CONST	EQU	B'01010010'	; 6-4:101 - FOSC/16, 3-0:0010 - AN1-   
TIMERI_CONST	EQU	.3		;      ( ) 
TIMERJ_CONST	EQU	.2		;      ( ) 
TIMERON_CONST	EQU	.7		;     ( ) 
TIMEROFF_CONST	EQU	.7		;     ( ) 
IZM_U_CONST	EQU	.187		;    13,5   Ubat=4,4 
;==============================================
;   EEPROM
;==============================================
;==============================================
;  
;==============================================
;==============================================
;  
;==============================================
	CBLOCK	20H	;       ( 64 )
IZM_U		;    
IZM_UI		;   
		; 0 -     
		; 1 -    
		; 2 - 
		; 3 - 
		; 4 -  
		; 5 - 
		; 6 -  
		; 7 -   
;-----   -----------------------------
TIMER_I		;    
TIMER_ON	;    
TIMER_OFF	;    

;-----    -----------------
	ENDC
;==============================================
;==============================================
;	
;==============================================
        org 0		;   
	goto	Start	;   
;==============================================
;	O 
;==============================================
;==============================================
;	 
;==============================================
Start
;==============================================
;	 
;==============================================
;----------------------------------------------
; 
;----------------------------------------------
;   RC  
	banksel	OSCCAL		;  1 
	call 3FFh		;    
	movwf OSCCAL 
	banksel	GPIO		;  0.
;  / 
	clrf	GPIO
	banksel	TRISIO		;  1.
	movlw	TRISIO_CONST
	movwf	TRISIO
	banksel	GPIO		;  0.
	movlw	ADCON0_CONST
	movwf	ADCON0		;   
	banksel	ANSEL		;  1.
	movlw	ANSEL_CONST
	movwf	ANSEL		;   
;----------------------------------------------
; 
;----------------------------------------------

;==============================================
;	  
;==============================================
main
	call	U_IZMER		;  
	call	ON_OFF		;  /
	goto	main		
;==============================================
;	 
;==============================================
;----------------------------------------------
;   
;: 	
;: W, IZM_U, IZM_UI, TIMER_I	
;: 
;: IZM_U 
;----------------------------------------------
U_IZMER
;    
	clrwdt			;   .
	btfsc	ADCON0,GO_DONE		; ,    
	goto	u_izmer_e		;  , 
	;    
	btfsc	IZM_UI,0		; ,    
	goto	u_izmer_u		; ,   
	incf	TIMER_I,f		;   
	btfss	TIMER_I,TIMERI_CONST	;    
	goto	u_izmer_e		; ,  , 
	clrf	TIMER_I			;    
	bsf	IZM_UI,0		;    
	movf	ADRESH,W		;     -  W
	movwf	IZM_U
	bsf	IZM_UI,1		;    
u_izmer_u
	;    
	incf	TIMER_I,f		;   
	btfss	TIMER_I,TIMERJ_CONST	;    
	goto	u_izmer_e		;  , 
	clrf	TIMER_I			;   
	bsf	ADCON0,GO_DONE		;  
	bcf	IZM_UI,0		;    
u_izmer_e
	return
;----------------------------------------------
; /   
;: 	
;: W, TIMER_ON, TIMER_OFF	
;: 
;: GPIO,2 
;----------------------------------------------
ON_OFF
	;    
	clrwdt				;   .
	btfss	IZM_UI,1		;     
	goto	on_off_e		; , 
	clrf	STATUS			;   STATUS
	bcf	IZM_UI,1		;     
	movf	IZM_U,w			;    W
	sublw	IZM_U_CONST		;    
	btfss	STATUS,C		;   
	goto	on_off_on
	goto	on_off_off
on_off_on
	clrf	TIMER_OFF		;   
	incf	TIMER_ON		;    
	btfss	TIMER_ON,TIMERON_CONST	;    
	goto	on_off_e		;   , 
	bcf	GPIO,2			;   
	clrf	TIMER_ON		;   
	goto	on_off_e		;  
on_off_off
	clrf	TIMER_ON		;   
	incf	TIMER_OFF		;    
	btfss	TIMER_OFF,TIMEROFF_CONST;    
	goto	on_off_e		;   , 
	bsf	GPIO,2			;   
	clrf	TIMER_OFF		;     
on_off_e	
	return
;==============================================
;	
;==============================================
	END


